# std::any_cast

From cppreference.com
< cpp‎ | utility‎ | any

template<class ValueType> ValueType any_cast(const any& operand); | (1) | (since C++17)
template<class ValueType> ValueType any_cast(any& operand); | (2) | (since C++17)
template<class ValueType> ValueType any_cast(any&& operand); | (3) | (since C++17)
template<class ValueType> const ValueType* any_cast(const any* operand); | (4) | (since C++17)
template<class ValueType> ValueType* any_cast(any* operand); | (5) | (since C++17)

Performs type-safe access to the contained object.

Let `U` be std::remove_cv_t<std::remove_reference_t<ValueType>>.

1) The program is ill-formed if is_constructible_v<ValueType, const U&> is not true.
2) The program is ill-formed if is_constructible_v<ValueType, U&> is not true.
3) The program is ill-formed if is_constructible_v<ValueType, U> is not true.

### Parameters

operand | - | target `any` object

### Return value

1-2) Returns static_cast<ValueType>(*std::any_cast<U>(&operand))
3) Returns static_cast<ValueType>(std::move(*std::any_cast<U>(&operand))).
4-5) If `operand` is not a null pointer, and the `typeid` of the requested `ValueType` matches that of the contents of `operand`, a pointer to the value contained by operand, otherwise a null pointer.

### Exceptions

1-3) Throws std::bad_any_cast if the `typeid` of the requested `ValueType` does not match that of the contents of `operand`.
4-5)
`noexcept` specification:
noexcept
Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/any/any_cast&oldid=91917"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template